package ru.mybgbilling.custom.dialog;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.view.ViewScoped;
import javax.imageio.IIOImage;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.imageio.stream.ImageOutputStream;
import javax.inject.Named;
import javax.servlet.http.Part;
import javax.xml.ws.Holder;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterListItem;
import ru.bitel.bgbilling.kernel.contract.api.common.service.ContractCardService;
import ru.bitel.bgbilling.kernel.contract.api.common.service.ContractParameterService;
import ru.bitel.common.TimeUtils;
import ru.bitel.common.Utils;
import ru.bitel.common.function.Async;
import ru.bitel.common.model.IdTitle;
import ru.bitel.common.model.MapHolder;
import ru.bitel.common.model.Result;
import ru.bitel.mybgbilling.kernel.common.AbstractBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;
import ru.mybgbilling.custom.dialog.registration.RegistrationDialogService;




 
@Named
@ViewScoped // 1.
@BGInjection // 2.
public class RegistrationDialogBean
    extends
    AbstractBean
    implements
    Serializable

{
    
    private static final Pattern patternRus = Pattern.compile("[а-яёА-ЯЁ]");
    private static final Pattern patternLat = Pattern.compile("[A-Za-z]");
    private static final Logger logger = LoggerFactory.getLogger( RegistrationDialogBean.class );

    @BGInject(module = false) // 2.
    private RegistrationDialogService registrationService;

    @BGInject(module = false)
    private ContractCardService contractCardService;

    @BGInject(module = false)
    private ContractParameterService contractParameterService;
    
    int step = 0 ; 
    String findError = "";
    List<IdTitle> tariffList;
//====================================
    String contractTitle = "";
    String contractType = "";
    String contractDate = TimeUtils.format( new Date(), "dd.MM.yyyy" );

    // ФИО
    String name = "";
    String lastName = "";
    String middleName = "";
    String birthDate = "";
    // Email
    String email = "";
    // Телефон
    String phone = "";
    // Тип документа (возможность выбора из списка: паспорт, права)
    int documentType=1;
    // Серия и номер
    String docSer = "";
    String docNum = "";
    // Кем выдан
    String docSubject = "";
    // Дата выдачи
    String docDate = "";

    // Адрес регистрации (выбор из реестра)
    String addressOfReg = "";
    // Адрес подключения (выбор из реестра)
    String addressOfAccount = "";
    // Комментарии (поле с возможностью внести запись)
    String comment = "";
    // ID и SN лепёшки или LHG (В последующем предусмотреть возможность
    // автоматического подтягивания).
  String macAddress = "";
  String manager = "";
    boolean checkPassport=true;
  //=================================
//    String contractTitle = "00-102387";
//    String contractType = "0";
//    String contractDate = TimeUtils.format( new Date(), "dd.MM.yyyy" );
//
//    // ФИО
//    String name = "Имя";
//    String lastName = "Фамилия";
//    String middleName = "Отчество";
//    String birthDate = "01.01.1990";
//    // Email
//    String email = "test@mail.ru";
//    // Телефон
//    String phone = "79177538133";
//    // Тип документа (возможность выбора из списка: паспорт, права)
//    int documentType;
//    // Серия и номер
//    String docSer = "1235";
//    String docNum = "456555";
//    // Кем выдан
//    String docSubject = "Рувд";
//    // Дата выдачи
//    String docDate = "01.02.2010";
//
//    // Адрес регистрации (выбор из реестра)
//    String addressOfReg = "Адрес1";
//    // Адрес подключения (выбор из реестра)
//    String addressOfAccount = "Адерс2";
//    // Комментарии (поле с возможностью внести запись)
//    String comment = "Кометарий";
//    // ID и SN лепёшки или LHG (В последующем предусмотреть возможность
//    // автоматического подтягивания).
//    String macAddress = "ABCDEFabcdef";
//    String manager = "Пеьро";
//=======================================
    // Фотографию паспорта со страниц сведений о пользователе и прописке (2-а
    // изображения)
    // Фотографии установленного каналообразующего оборудования, которые
    // позволят проконтролировать качество монтажа.
    
    int tariffId;
    int tvId;
    
    boolean tariffError = false;

    
    int PhotoSize = 7;
    Part[] photoDocument = new Part[PhotoSize];
    
     
    // =========
    Holder<DataHandler>[] photoDocumentHolder = new Holder[PhotoSize];
    String[] photoDocumentFileName = new String[PhotoSize];
    Long[] photoDocumentSize = new Long[PhotoSize];
    
   
        
    
    
    
    
    // =========

    private String resultText = null;
    private int cid = -1;

    @Override
    protected void init() // 3.
        throws BGException
    {
        logger.info( "init" );

        populate();
    }

    public void populate() // 4.
    {
        logger.info( "populate" );

    }
    
    // ===================

    public void findContract()
        throws BGException,
        IOException
    {
        logger.info( "findContract" );
        Result<IdTitle> res =  registrationService.findContract( contractTitle );
        cid = (Integer)res.getAttribute( "cid" );
        if(cid <0)
        {
            findError  = (String)res.getAttribute( "errorMsg" );
            step = 0; 
            return;
        }
        byte fc  = (byte)res.getAttribute( "fc" );
        if(fc==0)
        {
            tariffList = res.getList();
            step=1;
        }
        else
        {
            tariffError = (boolean)res.getAttribute( "tariffError" ); 
            step=2;
        }
        
        
        populate();
        
    }

    
    public void toLoadFoto()
    {
        step=3;
        populate();
    }
    // ===================

    public void registration()
        throws BGException,
        IOException
    {
        System.out.println( "name=>" + name );
        System.out.println( "lastName=>" + lastName );
        Map<String, String> param = new HashMap<>();

        param.put( "contractTitle",  contractTitle);
        param.put( "contractDate",   contractDate );
        param.put( "birthDate", birthDate )  ;

        param.put( "name", name );
        param.put( "lastName", lastName );
        param.put( "middleName", middleName );
        param.put( "email", email );
        param.put( "phone", phone );
        param.put( "documentType", String.valueOf( documentType ) );
        param.put( "docSer", docSer );
        param.put( "docNum", docNum );
        param.put( "docSubject", docSubject );
        param.put( "docDate", docDate );
        param.put( "addressOfReg", addressOfReg );
        param.put( "addressOfAccount", addressOfAccount );
        param.put( "comment", comment );
        param.put( "macAddress", macAddress );
        param.put( "tariffId",String.valueOf(  tariffId ));
        param.put( "tvId",String.valueOf(  tvId ));
        param.put( "agentId", String.valueOf( getContractId() ) );
        param.put( "manager", manager );
        //и все пользовательские
        
        objects.forEach( ( k, v ) -> {
            param.put( "param_" + k, v );
        } );
        //адрес

        IdTitle regStreet = regStreetsFromServer.get( searchRegStreetData );
        if ( regStreet == null )
        {
            param.put( "regStreetId", "" );
        }
        else
        {
            param.put( "regStreetId", String.valueOf( regStreet.getId() ) );
        }
        IdTitle regHouse = regHouseFromServer.get( searchRegHouseData );
        if ( regHouse == null )
        {
            param.put( "regHouseId", "" );
        }
        else
        {
            param.put( "regHouseId", String.valueOf( regHouse.getId() ) );
        }
        param.put( "regFlat", regFlat );
        param.put( "regRoom", regRoom );
        //===============================
        IdTitle conStreet = conStreetsFromServer.get( searchConStreetData );
        if ( conStreet == null )
        {
            param.put( "conStreetId", "" );
        }
        else
        {
            param.put( "conStreetId", String.valueOf( conStreet.getId() ) );
        }
        IdTitle conHouse = conHouseFromServer.get( searchConHouseData );
        if ( conHouse == null )
        {
            param.put( "conHouseId", "" );
        }
        else
        {
            param.put( "conHouseId", String.valueOf( conHouse.getId() ) );
        }
        param.put( "conFlat", conFlat );
        param.put( "conRoom", conRoom );
        
        
        

        readPhoto();
        System.out.println( "registrationContract..." );
        Result<String> res = registrationService.registrationContract( new MapHolder<>(param), photoDocumentFileName[0], photoDocumentHolder[0], photoDocumentSize[0] ,
                                                                   photoDocumentFileName[1], photoDocumentHolder[1] ,photoDocumentSize[1],
                                                                   photoDocumentFileName[2], photoDocumentHolder[2] ,photoDocumentSize[2],
                                                                   photoDocumentFileName[3], photoDocumentHolder[3] ,photoDocumentSize[3],
                                                                   photoDocumentFileName[4], photoDocumentHolder[4] ,photoDocumentSize[4],
                                                                   photoDocumentFileName[5], photoDocumentHolder[5] ,photoDocumentSize[5],
                                                                   photoDocumentFileName[6], photoDocumentHolder[6] ,photoDocumentSize[6]
                                                                   
                                                                   
                                                                  );
    
        System.out.println( "registrationContract...Ok" );
        cid = Utils.parseInt( (String)res.getAttribute( "cid" ), -1 );
        System.out.println( "cid=>"+cid );
        resultText = (String)res.getAttribute( "contractText" );
        System.out.println( "resultText=>"+resultText );
        populate();
    }
    
    private void readPhoto() throws IOException
    {
        for ( int i = 0; i < photoDocument.length; i++ )
        {
            if ( photoDocument[i] != null )
            {
                photoDocumentFileName[i] = getSubmittedFileName( photoDocument[i] );
                
                JpegStruct res  = compressJpeg( photoDocument[i].getInputStream());
                if(res.size>0)
                {
                    photoDocumentHolder[i] = createHolder( photoDocumentFileName[i],res.is );
                    photoDocumentSize[i] = res.size;
                }
                
                
                //photoDocumentHolder[i] = createHolder( photoDocument[i] );
                //photoDocumentSize[i] = photoDocument[i].getSize();

            }
        }
    }
    
    private Holder<DataHandler> createHolder( String fileName, InputStream is )
    {
        
        DataHandler dh = new DataHandler( new DataSource()
        {
            @Override
            public String getContentType()
            {
                return "application/octet-stream";
            }

            @Override
            public InputStream getInputStream()
                throws IOException
            {
                return is;
            }

            @Override
            public String getName()
            {
                return fileName;
            }

            @Override
            public OutputStream getOutputStream()
                throws IOException
            {
                return null;
            }
        } );

        Holder<DataHandler> holder = new Holder<DataHandler>( dh );
        return holder;
    }
    
    public String getName()
    {
        return name;
    }

    public void setName( String name )
    {
        this.name = name;
    }

    public String getLastName()
    {
        return lastName;
    }

    public void setLastName( String lastName )
    {
        this.lastName = lastName;
    }

    public String getMiddleName()
    {
        return middleName;
    }

    public void setMiddleName( String middleName )
    {
        this.middleName = middleName;
    }

    public String getEmail()
    {
        return email;
    }

    public void setEmail( String email )
    {
        this.email = email;
    }

    public String getPhone()
    {
        return phone;
    }

    public void setPhone( String phone )
    {
        this.phone = phone;
    }

    public void validatePhone( FacesContext context, UIComponent comp, Object value )
    {

        System.out.println( "phone validate method" );
        String phoneVal = (String)value;
        String msg = null;
        if ( Utils.isEmptyString( phoneVal ) )
        {
            msg = "Не заполнено поле \"Телефон\"";
        }
        else if ( !phoneVal.matches( "\\d+" ) )
        {
            msg = "В поле \"Телефон\" могут быть только цифры";
        }
        else if ( phoneVal.length() < 11 )
        {
            msg = "Телефон короче 11 цифр";
        }
        else if ( phoneVal.charAt( 0 )!='7' )
        {
            msg = "Телефон должен начинаться с 7";
        }
        addValidationMsg( context, comp, msg );
    }
    public void validateDocDate( FacesContext context, UIComponent comp, Object value )
    {

        System.out.println( " validate method" );
        String date = (String)value;
        String msg=null;
        if(Utils.isEmptyString( date))
        {
            msg = "Не заполнено поле \"Дата выдачи\"";
        }
        else
        {
            Calendar dt = TimeUtils.parseCalendar(  date, "dd.MM.yyyy" )  ;
            Calendar dt2 = new GregorianCalendar() ;
            if (dt==null||( dt.get( Calendar.YEAR )>  dt2.get( Calendar.YEAR )))
            {
                msg = "Неверно заполнено поле \"Дата выдачи\"";
            }
        }
        addValidationMsg( context, comp, msg );

    }
    
    public void validateMAC( FacesContext context, UIComponent comp, Object value )
    {

        
        String MAC = (String)value;
        String msg = null;
        if ( Utils.isEmptyString( MAC ) )
        {
            msg = "Не заполнено поле \"MAC\"";
        }
        else if ( !(
                    MAC.matches( "[ABCDEFabcdef0123456789]{12}" )
                    || MAC.matches( "^([0-9A-F]{2}[:-]){5}([0-9A-F]{2})$" )
                    ) )
        {
            msg = "Неверный формат поля \"MAC\"";
        }
        addValidationMsg( context, comp, msg );

    }
    

    public int getDocumentType()
    {
        return documentType;
    }

    public void setDocumentType( int documentType )
    {
        this.documentType = documentType;
    }

    public String getDocSer()
    {
        return docSer;
    }

    public void setDocSer( String docSer )
    {
        this.docSer = docSer;
    }

    public String getDocNum()
    {
        return docNum;
    }

    public void setDocNum( String docNum )
    {
        this.docNum = docNum;
    }

    public String getDocSubject()
    {
        return docSubject;
    }

    public void setDocSubject( String docSubject )
    {
        this.docSubject = docSubject;
    }

    public String getDocDate()
    {
        return docDate;
    }

    public void setDocDate( String docDate )
    {
        this.docDate = docDate;
    }

    public String getAddressOfAccount()
    {
        return addressOfAccount;
    }

    public void setAddressOfAccount( String addressOfAccount )
    {
        this.addressOfAccount = addressOfAccount;
    }

    public String getComment()
    {
        return comment;
    }

    public void setComment( String comment )
    {
        this.comment = comment;
    }

    public String getMacAddress()
    {
        return macAddress;
    }

    public void setMacAddress( String macAddress )
    {
        this.macAddress = macAddress;
    }

    public String getResultText()
    {
        return resultText;
    }

    public void setResultText( String resultText )
    {
        this.resultText = resultText;
    }

    public String getPatternId()
    {
        return contractTitle;
    }

    public void setPatternId( String patternId )
    {
        this.contractTitle = patternId;
    }

    public Part getPhotoDocument1()
    {
        return photoDocument[0];
    }

    public void setPhotoDocument1( Part fotoDocument1 )
    {
        this.photoDocument[0] = fotoDocument1;
    }

    public Part getPhotoDocument2()
    {
        return photoDocument[1];
    }

    public void setPhotoDocument2( Part fotoDocument2 )
    {
        this.photoDocument[1] = fotoDocument2;
    }

  

    public void exportContractCard()
        throws BGException
    {

        populate();

        final Holder<DataHandler> holder = new Holder<DataHandler>();

        contractCardService.contractCardExport( cid, "card_contract.xsl", holder );

        // String titleCard = Base64.decode( Base64.decodeWeb( ge ), "utf-8" );

        // имя PDF файла
        StringBuilder fileName = new StringBuilder();
        fileName.append( "card_contract.pdf" );

        writeToOutput( holder.value, fileName.toString(), false );
    }

   

    private Map<Integer, Async<List<ContractParameterListItem>>> сontractParameterListItemListMap = new HashMap<>();

    public List<ContractParameterListItem> getContractParameterListItemList( int parameterTypeId )
        throws BGException
    {
        return сontractParameterListItemListMap.computeIfAbsent( parameterTypeId, key -> Async.of( () -> {
            List<ContractParameterListItem> result = Utils.maskNull( contractParameterService.contractParameterListItemList( parameterTypeId ) );
            Collections.sort( result, ( a, b ) -> Utils.maskNull( a.getTitle() )
                                                       .compareTo( Utils.maskNull( b.getTitle() ) ) );
            return result;
        } ) ).get();
    }



    public String getContractTitle()
    {
        return contractTitle;
    }

    public void setContractTitle( String contractTitle )
    {
        this.contractTitle = contractTitle;
    }

    public String getContractType()
    {
        return contractType;
    }

    public void setContractType( String contractType )
    {
        this.contractType = contractType;
    }

    public String getContractDate()
    {
        return contractDate;
    }

    public void setContractDate( String contractDate )
    {
        this.contractDate = contractDate;
    }

    public String getBirthDate()
    {
        return birthDate;
    }

    public void setBirthDate( String birthDate )
    {
        this.birthDate = birthDate;
    }
    
    public String getAddressOfReg()
    {
        return addressOfReg;
    }

    public void setAddressOfReg( String addressOfReg )
    {
        this.addressOfReg = addressOfReg;
    }

    public int getStep()
    {
        return step;
    }

    public void setStep( int step )
    {
        this.step = step;
    }

    public String getFindError()
    {
        return findError;
    }

    public void setFindError( String findError )
    {
        this.findError = findError;
    }

    public List<IdTitle> getTariffList()
    {
        return tariffList;
    }

    public void setTariffList( List<IdTitle> tariffList )
    {
        this.tariffList = tariffList;
    }

    public int getTariffId()
    {
        return tariffId;
    }

    public void setTariffId( int tariffId )
    {
        this.tariffId = tariffId;
    }

    public boolean isTariffError()
    {
        return tariffError;
    }

    public void setTariffError( boolean tariffError )
    {
        this.tariffError = tariffError;
    }

    public Part getPhotoDocument3()
    {
        return photoDocument[2];
    }

    public void setPhotoDocument3( Part photoDocument3 )
    {
        this.photoDocument[2] = photoDocument3;
    }

    public Part getPhotoDocument4()
    {
        return photoDocument[3];
    }

    public void setPhotoDocument4( Part photoDocument4 )
    {
        this.photoDocument[3] = photoDocument4;
    }

    public Part getPhotoDocument5()
    {
        return photoDocument[4];
    }

    public void setPhotoDocument5( Part photoDocument5 )
    {
        this.photoDocument[4] = photoDocument5;
    }

    public Part getPhotoDocument6()
    {
        return photoDocument[5];
    }

    public void setPhotoDocument6( Part photoDocument6 )
    {
        this.photoDocument[5] = photoDocument6;
    }

    public Part getPhotoDocument7()
    {
        return photoDocument[6];
    }

    public void setPhotoDocument7( Part photoDocument7 )
    {
        this.photoDocument[6] = photoDocument7;
    }

    public int getTvId()
    {
        return tvId;
    }

    public void setTvId( int tvId )
    {
        this.tvId = tvId;
    }
    
    private class JpegStruct
    {
        InputStream is=null;
        long size =-1; 
    }
    
    private JpegStruct compressJpeg( InputStream in )
    {
        JpegStruct res = new JpegStruct(); 
        try
        {
            float quality = 0.8f;
            int scaledWidth = 1280;
            int scaledHeight = 720;
            // create a BufferedImage as the result of decoding the supplied
            // InputStream
            BufferedImage inputImage = ImageIO.read( in );

            BufferedImage outputImage = new BufferedImage( scaledWidth, scaledHeight, inputImage.getType() );
            Graphics2D g2d = outputImage.createGraphics();
            g2d.drawImage( inputImage, 0, 0, scaledWidth, scaledHeight, null );
            g2d.dispose();

            // get all image writers for JPG format
            Iterator<ImageWriter> writers = ImageIO.getImageWritersByFormatName( "jpg" );

            if ( !writers.hasNext() )
                throw new IllegalStateException( "No writers found" );

            ImageWriter writer = (ImageWriter)writers.next();
            ByteArrayOutputStream os = new ByteArrayOutputStream();
            ImageOutputStream ios = ImageIO.createImageOutputStream( os );
            writer.setOutput( ios );

            ImageWriteParam param = writer.getDefaultWriteParam();

            // compress to a given quality
            param.setCompressionMode( ImageWriteParam.MODE_EXPLICIT );
            param.setCompressionQuality( quality );

            // appends a complete image stream containing a single image and
            // associated stream and image metadata and thumbnails to the output
            writer.write( null, new IIOImage( outputImage, null, null ), param );

            byte[] bar = os.toByteArray();
            res.size = bar.length;
            res.is = new ByteArrayInputStream( bar );
            // close all streams
            os.close();
            ios.close();
            writer.dispose();
            
        }
        catch( IOException e )
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return res;
    }
    
    private boolean isValidatePassport (FacesContext context )
    {
        UIInput otherInput = (UIInput) context.getViewRoot().findComponent("notificationReadForm:checkPassport");
        return (Boolean)otherInput.getValue() ;
    }
    
    public void validateSer( FacesContext context, UIComponent comp, Object value )
    {
        if(!isValidatePassport(context))
        {
            return;
        }
        
        String ser = (String)value;
        String msg=null;
        if ( Utils.isEmptyString( ser)|| ser.length()!=4||!ser.matches(  "\\d+")   )
        {
            msg="Серия должна состоять из 4 цифр";
        }
        addValidationMsg( context, comp, msg );
    }
    
    public void validateNum( FacesContext context, UIComponent comp, Object value )
    {
        if(!isValidatePassport(context))
        {
            return;
        }
        
        String num = (String)value;
        String msg=null;
        if ( Utils.isEmptyString( num)|| num.length()!=6||!num.matches(  "\\d+")   )
        {
            msg="Номер должен состоять из 6 цифр";
        }
        addValidationMsg( context, comp, msg );
    }
    
    public void validateEmail( FacesContext context, UIComponent comp, Object value )
    {
        String email = (String)value;
        String msg=null;
        
        Matcher matcher = patternRus.matcher(email);
        if ( !Utils.isEmptyString( email ) )
        {

            if ( matcher.find() )
            {
                msg = "Содержит русские буквы ";
            }
            else if ( !email.contains( "@" )  )
            {
                msg = "Не содержит @";
            }
        }
        addValidationMsg( context, comp, msg );
    }
    
    public void validateName( FacesContext context, UIComponent comp, Object value )
    {
        validateFIO( "\"Имя\"", context, comp, value );
    }
    public void validateLastName( FacesContext context, UIComponent comp, Object value )
    {
        validateFIO( "\"Фамилия\"", context, comp, value );
    }
    public void validateMidName( FacesContext context, UIComponent comp, Object value )
    {
        validateFIO( "\"Отчество\"", context, comp, value );
    }
    public void validateDocSubject( FacesContext context, UIComponent comp, Object value )
    {
        validateFIO( "\"Кем выдан\"", context, comp, value );
    }
    public void validateManager( FacesContext context, UIComponent comp, Object value )
    {
        validateFIO( "\"Фамилия менеджера\"", context, comp, value );
    }
    
    
    public void validateFIO( String name, FacesContext context, UIComponent comp, Object value )
    {
        String fio = (String)value;
        String msg = null;
        
        Matcher matcher = patternLat.matcher( fio );
        if ( Utils.isEmptyString( fio ) )
        {
            msg = "Не заполнено поле "+name;
        }
        else if ( matcher.find() )
        {
            msg = "Cодержит латинские буквы ";
        }
        addValidationMsg( context, comp, msg );
    }
    
    
    
    
    private void addValidationMsg( FacesContext context, UIComponent comp, String msg )
    {
        if(msg!=null)
        {
            ((UIInput)comp).setValid( false );
            FacesMessage message = new FacesMessage( msg );
            context.addMessage( comp.getClientId( context ), message );
        }
    }

    public String getManager()
    {
        return manager;
    }

    public void setManager( String manager )
    {
        this.manager = manager;
    }
    
    public void validateBirthDate( FacesContext context, UIComponent comp, Object value )
    {

        System.out.println( " validate method" );
        String date = (String)value;
        String msg=null;
        if(Utils.isEmptyString( date))
        {
            msg = "Не заполнено поле \"Дата рождения\"";
        }
        else
        {
            Calendar dt = TimeUtils.parseCalendar(  date, "dd.MM.yyyy" )  ;
            
            Calendar dt2 = new GregorianCalendar() ;
            dt2.add( Calendar.YEAR, -16 );
            Calendar dt3 = new GregorianCalendar() ;
            dt3.add( Calendar.YEAR, -100 );
            if (dt==null
            ||( dt.compareTo( dt2 )>0)
            ||( dt.compareTo( dt3 )<0))
            {
                msg = "Неверно заполнено поле \"Дата рождения\"";
            }
        }
        addValidationMsg( context, comp, msg );

    }
    
    
    
    private List<String> searchRegStreetResult = new ArrayList<>();
    private String searchRegStreetData;
    private Map<String,IdTitle> regStreetsFromServer = new HashMap<>();
    
    private List<String> searchConStreetResult = new ArrayList<>();
    private String searchConStreetData;
    private Map<String,IdTitle> conStreetsFromServer = new HashMap<>();

    public void searchRegStreet()
    {
        searchStreet( searchRegStreetResult, searchRegStreetData, regStreetsFromServer );
    }

    public void searchConStreet()
    {
        searchStreet( searchConStreetResult, searchConStreetData, conStreetsFromServer );
    }
    
    private void searchStreet(List<String> searchStreetResult, String searchStreetData, Map<String,IdTitle> streetsFromServer)
    {
        searchStreetResult.clear();
        if( Utils.isBlankString( searchStreetData ) )
        {
            return;
        }
        if(searchStreetData.length()<3)
        {
            return;
        }
        String stname="";
        String cityTitle="";
        int pos = searchStreetData.indexOf( '(' );
        if ( pos < 0 )
        {
            stname= searchStreetData.trim() ;
        }
        else
        {
            stname = searchStreetData.substring( 0, pos ).trim() ;
            if ( pos <  searchStreetData.length() - 1 )
            {
                cityTitle =  searchStreetData.substring( pos + 1 ).trim() ;
            }
        }
        Result<IdTitle> res = registrationService.getAddresStreet( stname, cityTitle );
        streetsFromServer.clear();
        streetsFromServer.putAll( res.getList()
                                     .stream()
                                     .collect( Collectors.toMap( i -> i.getTitle(), i -> i, ( v1, v2 ) -> v1, LinkedHashMap::new ) ) );
        searchStreetResult.clear();
        searchStreetResult.addAll( streetsFromServer.values().stream().map( i->i.getTitle() ).collect( Collectors.toList() )  );
    }

 
    public List<String> getSearchRegStreetResult()
    {
        return searchRegStreetResult;
    }

    public void setSearchRegStreetResult( List<String> searchStreetResult )
    {
        this.searchRegStreetResult = searchStreetResult;
    }

    public String getSearchRegStreetData()
    {
        return searchRegStreetData;
    }

    public void setSearchRegStreetData( String searchStreetData )
    {
        this.searchRegStreetData = searchStreetData;
    }
    
    
    public List<String> getSearchConStreetResult()
    {
        return searchConStreetResult;
    }

    public void setSearchConStreetResult( List<String> searchStreetResult )
    {
        this.searchConStreetResult = searchStreetResult;
    }

    public String getSearchConStreetData()
    {
        return searchConStreetData;
    }

    public void setSearchConStreetData( String searchStreetData )
    {
        this.searchConStreetData = searchStreetData;
    }
    
   
    
    public void inputSearchRegStreetResult( String str )
    {
        searchRegStreetData = str;
        searchRegStreetResult.clear();
        loadHouseFromServer(regStreetsFromServer,regHouseFromServer,searchRegHouseResult,str);
    }
    public void inputSearchConStreetResult( String str )
    {
        searchConStreetData = str;
        searchConStreetResult.clear();
        loadHouseFromServer(conStreetsFromServer,conHouseFromServer,searchConHouseResult,str);
    }
   
    
    ////==================
  
    
    
    private List<String> searchRegHouseResult = new ArrayList<>();
    private String searchRegHouseData;
    Map<String,IdTitle> regHouseFromServer = new LinkedHashMap<>();
    
    
    
    private List<String> searchConHouseResult = new ArrayList<>();
    private String searchConHouseData;
    Map<String,IdTitle> conHouseFromServer = new LinkedHashMap<>();;

    private void loadHouseFromServer(Map<String,IdTitle> streetsFromServer,Map<String,IdTitle> houseFromServer,List<String> searchHouseResult, String streetName)
    {
        searchHouseResult.clear();
        if ( streetsFromServer == null || houseFromServer == null )
        {
            return;
        }
        IdTitle street = streetsFromServer.get( streetName );
        if ( street == null )
        {
            return;
        }
        Result<IdTitle> res = registrationService.fillListByHouses( street.getId() );
        houseFromServer.clear();
        houseFromServer.putAll( res.getList()
                                .stream()
                                .collect( Collectors.toMap( i -> i.getTitle(), i -> i, ( v1, v2 ) -> v1, LinkedHashMap::new ) ) );

        searchHouseResult.addAll( houseFromServer.values()
                                                 .stream()
                                                 .map( i -> i.getTitle() )
                                                 .collect( Collectors.toList() ) );
    }
    
    public void searchRegHouse()
    {
        searchHouse(regStreetsFromServer,regHouseFromServer, searchRegHouseData, searchRegHouseResult);
    };
    public void searchConHouse()
    {
        searchHouse(conStreetsFromServer,conHouseFromServer, searchConHouseData, searchConHouseResult);
    };
    
    private void searchHouse(Map<String,IdTitle> streetsFromServer,Map<String,IdTitle> houseFromServer,String searchHouseData,List<String> searchHouseResult) 
    {
        searchHouseResult.clear();
        
        if ( streetsFromServer == null || houseFromServer == null )
        {
            return;
        }

        if( Utils.isBlankString( searchHouseData ) )
        {
            return;
        }
      
       
        searchHouseResult.clear();
        searchHouseResult.addAll( houseFromServer.values().stream()
                                  .filter( i->i.getTitle().contains( searchHouseData ) )
                                   .map( i->i.getTitle() ).collect( Collectors.toList() )  );
        

    }
    public List<String> getSearchRegHouseResult()
    {
        return searchRegHouseResult;
    }

    public void setSearchRegHouseResult( List<String> searchHouseResult )
    {
        this.searchRegHouseResult = searchHouseResult;
    }
    
    public List<String> getSearchConHouseResult()
    {
        return searchConHouseResult;
    }

    public void setSearchConHouseResult( List<String> searchHouseResult )
    {
        this.searchConHouseResult = searchHouseResult;
    }

    public String getSearchRegHouseData()
    {
        return searchRegHouseData;
    }

    public void setSearchRegHouseData( String searchHouseData )
    {
        this.searchRegHouseData = searchHouseData;
    }
    
      public String getSearchConHouseData()
    {
        return searchConHouseData;
    }

    public void setSearchConHouseData( String searchHouseData )
    {
        searchConHouseData = searchHouseData;
    }
    
    public void inputSearchRegHouseResult(  String str )
    {
        searchRegHouseData = str;
        searchRegHouseResult.clear();
    }
    public void inputSearchConHouseResult(  String str )
    {
        searchConHouseData = str;
        searchConHouseResult.clear();
    }

   
    
    private String regFlat ="";
    private String regRoom="";
    private String conFlat ="";
    private String conRoom="";

    public String getRegFlat()
    {
        return regFlat;
    }

    public void setRegFlat( String flat )
    {
        this.regFlat = flat;
    }

    public String getRegRoom()
    {
        return regRoom;
    }

    public void setRegRoom( String room )
    {
        this.regRoom = room;
    }
    
 
    private String addrTest;

    public String getAddrTest()
    {
        return addrTest;
    }

    public void setAddrTest( String addrTest )
    {
        this.addrTest = addrTest;
    }

    public void validateRegFlat( FacesContext context, UIComponent comp, Object value )
    {
        validateFlat( searchRegStreetData, regStreetsFromServer,regHouseFromServer,searchRegHouseData,context, comp, value );
    }
    public void validateConFlat( FacesContext context, UIComponent comp, Object value )
    {
        validateFlat( searchConStreetData, conStreetsFromServer,conHouseFromServer,searchConHouseData,context, comp, value );
    }
    private void validateFlat( String searchStreetData, Map<String,IdTitle> streetsFromServer,Map<String,IdTitle> houseFromServer,String searchHouseData, FacesContext context, UIComponent comp, Object value )
    {
        String msg = null;
        if(streetsFromServer==null)
        {
            msg = "Не верно заполнено поле \"Улица\"";
            addValidationMsg( context, comp, msg );
            return;
        }
        
        String streetName = searchStreetData;
        IdTitle street = streetsFromServer.get( streetName );
        if(street==null)
        {
            msg = "Не верно заполнено поле \"Улица\"";
            addValidationMsg( context, comp, msg );
            return;
        }
        
        
        if(houseFromServer==null)
        {
            msg = "Не верно заполнено поле \"Дом\"";
            addValidationMsg( context, comp, msg );
            return;
        }
        String houseName = searchHouseData;
        IdTitle house = houseFromServer.get( houseName );
        if(house==null)
        {
            msg = "Не верно заполнено поле \"Дом\"";
            addValidationMsg( context, comp, msg );
            return;
        }
    }

    public String getConFlat()
    {
        return conFlat;
    }

    public void setConFlat( String conFlat )
    {
        this.conFlat = conFlat;
    }

    public String getConRoom()
    {
        return conRoom;
    }

    public void setConRoom( String conRoom )
    {
        this.conRoom = conRoom;
    }
    
    
    
    private Map<String, String> objects = new HashMap<>();

    public void add(String key, String value) {
        objects.put(key, value);

    }

    public Map<String, String> getObjectsMap() {
        return objects;
    }

    public boolean isCheckPassport()
    {
        return checkPassport;
    }

    public void setCheckPassport( boolean checkPassport )
    {
        this.checkPassport = checkPassport;
    }
 
  
}