package ru.mybgbilling.custom.test;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Serializable;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.view.ViewScoped;
import javax.imageio.IIOImage;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.imageio.stream.ImageOutputStream;
import javax.inject.Named;
import javax.servlet.MultipartConfigElement;
import javax.servlet.http.Part;
import javax.xml.ws.Holder;

import org.apache.camel.language.Bean;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.bgbilling.kernel.contract.api.common.bean.parameter.ContractParameterListItem;
import ru.bitel.bgbilling.kernel.contract.api.common.service.ContractCardService;
import ru.bitel.bgbilling.kernel.contract.api.common.service.ContractParameterService;
import ru.bitel.common.TimeUtils;
import ru.bitel.common.Utils;
import ru.bitel.common.function.Async;
import ru.bitel.common.model.IdTitle;
import ru.bitel.common.model.MapHolder;
import ru.bitel.common.model.Result;
import ru.bitel.mybgbilling.kernel.common.AbstractBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInject;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;
import ru.mybgbilling.custom.dialog.registration.RegistrationDialogService;


 
@Named
@ViewScoped // 1.
@BGInjection // 2.
public class RegistrationTestBean
    extends
    AbstractBean
    implements
    Serializable

{
    
   
    
    private static final Logger logger = LoggerFactory.getLogger( RegistrationTestBean.class );

    @BGInject(module = false) // 2.
    private RegistrationDialogService registrationService;

    @BGInject(module = false)
    private ContractCardService contractCardService;

    @BGInject(module = false)
    private ContractParameterService contractParameterService;
    
    int step = 0 ; 
    String findError = "";
    List<IdTitle> tariffList;

    String contractTitle = "";
    String contractType = "";
    String contractDate = TimeUtils.format( new Date(), "dd.MM.yyyy" );

    // ФИО
    String name = "";
    String lastName = "";
    String middleName = "";
    String birthDate = "";
    // Email
    String email = "";
    // Телефон
    String phone = "";
    // Тип документа (возможность выбора из списка: паспорт, права)
    int documentType=1;
    // Серия и номер
    String docSer = "";
    String docNum = "";
    // Кем выдан
    String docSubject = "";
    // Дата выдачи
    String docDate = "";

    // Адрес регистрации (выбор из реестра)
    String addressOfReg = "";
    // Адрес подключения (выбор из реестра)
    String addressOfAccount = "";
    // Комментарии (поле с возможностью внести запись)
    String comment = "";
    // ID и SN лепёшки или LHG (В последующем предусмотреть возможность
    // автоматического подтягивания).
  String macAddress = "";

//    String contractTitle = "00-102387";
//    String contractType = "0";
//    String contractDate = TimeUtils.format( new Date(), "dd.MM.yyyy" );
//
//    // ФИО
//    String name = "Имя";
//    String lastName = "Фамилия";
//    String middleName = "Отчество";
//    String birthDate = "01.01.1990";
//    // Email
//    String email = "test.mail.ru";
//    // Телефон
//    String phone = "89177538133";
//    // Тип документа (возможность выбора из списка: паспорт, права)
//    int documentType;
//    // Серия и номер
//    String docSer = "123";
//    String docNum = "456";
//    // Кем выдан
//    String docSubject = "Рувд";
//    // Дата выдачи
//    String docDate = "01.02.2010";
//
//    // Адрес регистрации (выбор из реестра)
//    String addressOfReg = "Адрес1";
//    // Адрес подключения (выбор из реестра)
//    String addressOfAccount = "Адерс2";
//    // Комментарии (поле с возможностью внести запись)
//    String comment = "Кометарий";
//    // ID и SN лепёшки или LHG (В последующем предусмотреть возможность
//    // автоматического подтягивания).
//    String macAddress = "12333";

    // Фотографию паспорта со страниц сведений о пользователе и прописке (2-а
    // изображения)
    // Фотографии установленного каналообразующего оборудования, которые
    // позволят проконтролировать качество монтажа.
    
    int tariffId;
    int tvId;
    
    boolean tariffError = false;

    Part photoDocument1;
    Part photoDocument2;
    Part photoDocument3;
    Part photoDocument4;
    Part photoDocument5;
    Part photoDocument6;
    Part photoDocument7;
    
    // =========
    Holder<DataHandler> photoDocument1Holder = null;
    String photoDocument1FileName = null;
    Long photoDocument1Size = -1L;
    
    Holder<DataHandler> photoDocument2Holder = null;
    String photoDocument2FileName = null;
    Long photoDocument2Size = -1L;
    
    Holder<DataHandler> photoDocument3Holder = null;
    String photoDocument3FileName = null;
    Long photoDocument3Size = -1L;
    
    Holder<DataHandler> photoDocument4Holder = null;
    String photoDocument4FileName = null;
    Long photoDocument4Size = -1L;
    
    Holder<DataHandler> photoDocument5Holder = null;
    String photoDocument5FileName = null;
    Long photoDocument5Size = -1L;
    
    Holder<DataHandler> photoDocument6Holder = null;
    String photoDocument6FileName = null;
    Long photoDocument6Size = -1L;
    
    Holder<DataHandler> photoDocument7Holder = null;
    String photoDocument7FileName = null;
    Long photoDocument7Size = -1L;
        
    
    
    
    
    // =========

    private String resultText = null;
    private int cid = -1;

    @Override
    protected void init() // 3.
        throws BGException
    {
        logger.info( "init" );

        populate();
    }

    public void populate() // 4.
    {
        logger.info( "populate" );

    }
    
    // ===================

    public void findContract()
        throws BGException,
        IOException
    {
        logger.info( "findContract" );
        Result<IdTitle> res =  registrationService.findContract( contractTitle );
        cid = (Integer)res.getAttribute( "cid" );
        if(cid <0)
        {
            findError = "Договор не найден";
            step =0; 
            return;
        }
        byte fc  = (byte)res.getAttribute( "fc" );
        if(fc==0)
        {
            tariffList = res.getList();
            step=1;
        }
        else
        {
            tariffError = (boolean)res.getAttribute( "tariffError" ); 
            step=2;
        }
        
        
        populate();
        
    }

    // ===================

    public void registration()
        throws BGException,
        IOException
    {
       

        readPhoto();
        System.out.println( "registrationContract..." );
       
        
        
        populate();
    }
    
    private class JpegStruct
    {
        InputStream is=null;
        long size =-1; 
    }
    
    private JpegStruct compressJpeg( InputStream in )
    {
        JpegStruct res = new JpegStruct(); 
        try
        {
            float quality = 0.7f;
            int scaledWidth = 800;
            int scaledHeight = 600;
            // create a BufferedImage as the result of decoding the supplied
            // InputStream
            BufferedImage inputImage = ImageIO.read( in );

            BufferedImage outputImage = new BufferedImage( scaledWidth, scaledHeight, inputImage.getType() );
            Graphics2D g2d = outputImage.createGraphics();
            g2d.drawImage( inputImage, 0, 0, scaledWidth, scaledHeight, null );
            g2d.dispose();

            // get all image writers for JPG format
            Iterator<ImageWriter> writers = ImageIO.getImageWritersByFormatName( "jpg" );

            if ( !writers.hasNext() )
                throw new IllegalStateException( "No writers found" );

            ImageWriter writer = (ImageWriter)writers.next();
            ByteArrayOutputStream os = new ByteArrayOutputStream();
            ImageOutputStream ios = ImageIO.createImageOutputStream( os );
            writer.setOutput( ios );

            ImageWriteParam param = writer.getDefaultWriteParam();

            // compress to a given quality
            param.setCompressionMode( ImageWriteParam.MODE_EXPLICIT );
            param.setCompressionQuality( quality );

            // appends a complete image stream containing a single image and
            // associated stream and image metadata and thumbnails to the output
            writer.write( null, new IIOImage( outputImage, null, null ), param );

            byte[] bar = os.toByteArray();
            res.size = bar.length;
            res.is = new ByteArrayInputStream( bar );
            // close all streams
            os.close();
            ios.close();
            writer.dispose();
            
        }
        catch( IOException e )
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return res;
    }
    
    private void readPhoto() throws IOException
    {
        if ( photoDocument1 != null )
        {
            photoDocument1FileName = getSubmittedFileName( photoDocument1 );
            JpegStruct res  = compressJpeg( photoDocument1.getInputStream());
            if(res.size>0)
            {
                photoDocument1Holder = createHolder( photoDocument1FileName,res.is );
                photoDocument1Size = res.size;
            }
            //photoDocument1Holder = createHolder( photoDocument1 );
            //photoDocument1Size = photoDocument1.getSize();
            
        }
//        if ( photoDocument2 != null )
//        {
//            photoDocument2FileName = getSubmittedFileName( photoDocument2 );
//            photoDocument2Holder = createHolder( photoDocument2 );
//            photoDocument2Size = photoDocument2.getSize();
//        }
//        
//        if ( photoDocument3 != null )
//        {
//            photoDocument3FileName = getSubmittedFileName( photoDocument3 );
//            photoDocument3Holder = createHolder( photoDocument3 );
//            photoDocument3Size = photoDocument3.getSize();
//        }
//        
//        
//        if ( photoDocument4 != null )
//        {
//            photoDocument4FileName = getSubmittedFileName( photoDocument4 );
//            photoDocument4Holder = createHolder( photoDocument4 );
//            photoDocument4Size = photoDocument4.getSize();
//        }
//        
//        if ( photoDocument5 != null )
//        {
//            photoDocument5FileName = getSubmittedFileName( photoDocument5 );
//            photoDocument5Holder = createHolder( photoDocument5 );
//            photoDocument5Size = photoDocument5.getSize();
//        }
//        
//        if ( photoDocument6 != null )
//        {
//            photoDocument6FileName = getSubmittedFileName( photoDocument6 );
//            photoDocument6Holder = createHolder( photoDocument6 );
//            photoDocument6Size = photoDocument6.getSize();
//        }
//        
//        if ( photoDocument7 != null )
//        {
//            photoDocument7FileName = getSubmittedFileName( photoDocument7 );
//            photoDocument7Holder = createHolder( photoDocument7 );
//            photoDocument7Size = photoDocument7.getSize();
//        }
     
       
    }
    
    private Holder<DataHandler> createHolder( Part part )
    {
        final String fileName = getSubmittedFileName( part );
        DataHandler dh = new DataHandler( new DataSource()
        {
            @Override
            public String getContentType()
            {
                return "application/octet-stream";
            }

            @Override
            public InputStream getInputStream()
                throws IOException
            {
                return part.getInputStream();
            }

            @Override
            public String getName()
            {
                return fileName;
            }

            @Override
            public OutputStream getOutputStream()
                throws IOException
            {
                return null;
            }
        } );

        Holder<DataHandler> holder = new Holder<DataHandler>( dh );
        return holder;
    }
    
    private Holder<DataHandler> createHolder( String fileName, InputStream is )
    {
        
        DataHandler dh = new DataHandler( new DataSource()
        {
            @Override
            public String getContentType()
            {
                return "application/octet-stream";
            }

            @Override
            public InputStream getInputStream()
                throws IOException
            {
                return is;
            }

            @Override
            public String getName()
            {
                return fileName;
            }

            @Override
            public OutputStream getOutputStream()
                throws IOException
            {
                return null;
            }
        } );

        Holder<DataHandler> holder = new Holder<DataHandler>( dh );
        return holder;
    }

    public String getName()
    {
        return name;
    }

    public void setName( String name )
    {
        this.name = name;
    }

    public String getLastName()
    {
        return lastName;
    }

    public void setLastName( String lastName )
    {
        this.lastName = lastName;
    }

    public String getMiddleName()
    {
        return middleName;
    }

    public void setMiddleName( String middleName )
    {
        this.middleName = middleName;
    }

    public String getEmail()
    {
        return email;
    }

    public void setEmail( String email )
    {
        this.email = email;
    }

    public String getPhone()
    {
        return phone;
    }

    public void setPhone( String phone )
    {
        this.phone = phone;
    }

    public void validatePhone( FacesContext context, UIComponent comp, Object value )
    {

        System.out.println( "phone validate method" );
        String phoneVal = (String)value;
        String msg = null;
        if ( Utils.isEmptyString( phoneVal ) )
        {
            msg = "Не заполнено поле \"Телефон\"";
        }
        else if ( !phoneVal.matches( "\\d+" ) )
        {
            msg = "В поле \"Телефон\" могут быть только цифры";
        }
        else if ( phoneVal.length() < 11 )
        {
            msg = "Телефон короче 11 цифр";
        }
        if ( msg != null )
        {
            ((UIInput)comp).setValid( false );
            FacesMessage message = new FacesMessage( msg );
            context.addMessage( comp.getClientId( context ), message );
        }

    }
    public void validateDocDate( FacesContext context, UIComponent comp, Object value )
    {

        System.out.println( " validate method" );
        String date = (String)value;
        String msg=null;
        if(date==null)
        {
            msg = "Не заполнено поле \"Дата выдачи\"";
        }
        else
        {
            Calendar dt = TimeUtils.parseCalendar(  date, "dd.MM.yyyy" )  ;
            Calendar dt2 = new GregorianCalendar() ;
            if ( dt.get( Calendar.YEAR )>  dt2.get( Calendar.YEAR ))
            {
                msg = "Неверно заполнено поле \"Дата выдачи\"";
            }
        }
        
        if ( msg != null )
        {
            ((UIInput)comp).setValid( false );
            FacesMessage message = new FacesMessage( msg );
            context.addMessage( comp.getClientId( context ), message );
        }

    }

    public int getDocumentType()
    {
        return documentType;
    }

    public void setDocumentType( int documentType )
    {
        this.documentType = documentType;
    }

    public String getDocSer()
    {
        return docSer;
    }

    public void setDocSer( String docSer )
    {
        this.docSer = docSer;
    }

    public String getDocNum()
    {
        return docNum;
    }

    public void setDocNum( String docNum )
    {
        this.docNum = docNum;
    }

    public String getDocSubject()
    {
        return docSubject;
    }

    public void setDocSubject( String docSubject )
    {
        this.docSubject = docSubject;
    }

    public String getDocDate()
    {
        return docDate;
    }

    public void setDocDate( String docDate )
    {
        this.docDate = docDate;
    }

    public String getAddressOfAccount()
    {
        return addressOfAccount;
    }

    public void setAddressOfAccount( String addressOfAccount )
    {
        this.addressOfAccount = addressOfAccount;
    }

    public String getComment()
    {
        return comment;
    }

    public void setComment( String comment )
    {
        this.comment = comment;
    }

    public String getMacAddress()
    {
        return macAddress;
    }

    public void setMacAddress( String macAddress )
    {
        this.macAddress = macAddress;
    }

    public String getResultText()
    {
        return resultText;
    }

    public void setResultText( String resultText )
    {
        this.resultText = resultText;
    }

    public String getPatternId()
    {
        return contractTitle;
    }

    public void setPatternId( String patternId )
    {
        this.contractTitle = patternId;
    }

    public Part getPhotoDocument1()
    {
        return photoDocument1;
    }

    public void setPhotoDocument1( Part fotoDocument1 )
    {
        this.photoDocument1 = fotoDocument1;
    }

    public Part getPhotoDocument2()
    {
        return photoDocument2;
    }

    public void setPhotoDocument2( Part fotoDocument2 )
    {
        this.photoDocument2 = fotoDocument2;
    }

  

    public void exportContractCard()
        throws BGException
    {

        populate();

        final Holder<DataHandler> holder = new Holder<DataHandler>();

        contractCardService.contractCardExport( cid, "card_contract.xsl", holder );

        // String titleCard = Base64.decode( Base64.decodeWeb( ge ), "utf-8" );

        // имя PDF файла
        StringBuilder fileName = new StringBuilder();
        fileName.append( "card_contract.pdf" );

        writeToOutput( holder.value, fileName.toString(), false );
    }

   

    private Map<Integer, Async<List<ContractParameterListItem>>> сontractParameterListItemListMap = new HashMap<>();

    public List<ContractParameterListItem> getContractParameterListItemList( int parameterTypeId )
        throws BGException
    {
        return сontractParameterListItemListMap.computeIfAbsent( parameterTypeId, key -> Async.of( () -> {
            List<ContractParameterListItem> result = Utils.maskNull( contractParameterService.contractParameterListItemList( parameterTypeId ) );
            Collections.sort( result, ( a, b ) -> Utils.maskNull( a.getTitle() )
                                                       .compareTo( Utils.maskNull( b.getTitle() ) ) );
            return result;
        } ) ).get();
    }



    public String getContractTitle()
    {
        return contractTitle;
    }

    public void setContractTitle( String contractTitle )
    {
        this.contractTitle = contractTitle;
    }

    public String getContractType()
    {
        return contractType;
    }

    public void setContractType( String contractType )
    {
        this.contractType = contractType;
    }

    public String getContractDate()
    {
        return contractDate;
    }

    public void setContractDate( String contractDate )
    {
        this.contractDate = contractDate;
    }

    public String getBirthDate()
    {
        return birthDate;
    }

    public void setBirthDate( String birthDate )
    {
        this.birthDate = birthDate;
    }
    
    public String getAddressOfReg()
    {
        return addressOfReg;
    }

    public void setAddressOfReg( String addressOfReg )
    {
        this.addressOfReg = addressOfReg;
    }

    public int getStep()
    {
        return step;
    }

    public void setStep( int step )
    {
        this.step = step;
    }

    public String getFindError()
    {
        return findError;
    }

    public void setFindError( String findError )
    {
        this.findError = findError;
    }

    public List<IdTitle> getTariffList()
    {
        return tariffList;
    }

    public void setTariffList( List<IdTitle> tariffList )
    {
        this.tariffList = tariffList;
    }

    public int getTariffId()
    {
        return tariffId;
    }

    public void setTariffId( int tariffId )
    {
        this.tariffId = tariffId;
    }

    public boolean isTariffError()
    {
        return tariffError;
    }

    public void setTariffError( boolean tariffError )
    {
        this.tariffError = tariffError;
    }

    public Part getPhotoDocument3()
    {
        return photoDocument3;
    }

    public void setPhotoDocument3( Part photoDocument3 )
    {
        this.photoDocument3 = photoDocument3;
    }

    public Part getPhotoDocument4()
    {
        return photoDocument4;
    }

    public void setPhotoDocument4( Part photoDocument4 )
    {
        this.photoDocument4 = photoDocument4;
    }

    public Part getPhotoDocument5()
    {
        return photoDocument5;
    }

    public void setPhotoDocument5( Part photoDocument5 )
    {
        this.photoDocument5 = photoDocument5;
    }

    public Part getPhotoDocument6()
    {
        return photoDocument6;
    }

    public void setPhotoDocument6( Part photoDocument6 )
    {
        this.photoDocument6 = photoDocument6;
    }

    public Part getPhotoDocument7()
    {
        return photoDocument7;
    }

    public void setPhotoDocument7( Part photoDocument7 )
    {
        this.photoDocument7 = photoDocument7;
    }

    public int getTvId()
    {
        return tvId;
    }

    public void setTvId( int tvId )
    {
        this.tvId = tvId;
    }   

  
}